> For the complete documentation index, see [llms.txt](https://docs.licensespring.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.licensespring.com/license-api/license-activation-and-deactivation/deactivate-bundle-online-method.md).

# Deactivate Bundle (Online Method)

### Endpoint

* Method: `POST`
* Path: `/api/v4/deactivate_bundle`
* Description: Deactivates a bundle license for a device and returns `license_deactivated` on success.

### Authentication

See [License API Authorization](/license-api/license-api-authorization.md).

#### Required headers

* `Date` (string) — RFC7231 GMT date string
* `Authorization` (string) — signature or bearer token

#### Recommended headers

* `Accept: application/json`
* `Content-Type: application/json`

### Request

#### Body parameters

Required:

* `hardware_id` (string)
* `product` (string) — Bundle product short code

One of:

* `license_key` (string)
* `username` + `password` (string)
* `id_token` (use access\_token value) + `customer_account_code` (string)
* `code` + `customer_account_code` (string)

Optional:

* `license_id` (number)
* `sdk_ver` (string)
* device metadata fields (`is_vm`, `vm_info`, `os_ver`, `hostname`, `ip`, `mac_address`, ...)

#### Minimal example (JSON)

```json
{
  "hardware_id": "some-unique-id",
  "product": "BUNDLE",
  "license_key": "AAAA-BBBB-CCCC-DDDD"
}
```

### Schema

<details>

<summary><strong>Request schema (TypeScript + JSON Schema)</strong></summary>

**TypeScript**

```typescript
type BundleDeactivationRequestBody = ({

  // for key-based licenses:
  license_key: string

} | {

  // for user-based licenses:
  username: string
  password: string

} | {

  // for user-based licenses using single sign-on Implicit grant:
  id_token: string
  customer_account_code: string

} | {

  // for user-based licenses using single sign-on Authorization code grant:
  code: string
  customer_account_code: string

}) & {
  hardware_id: string
  product: string

  license_id?: number | undefined
  sdk_ver?: string | undefined
}
```

**JSON Schema**

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "allOf": [
    {
      "oneOf": [
        {
          "type": "object",
          "properties": {
            "license_key": { "type": "string" }
          },
          "required": ["license_key"],
          "additionalProperties": false
        },
        {
          "type": "object",
          "properties": {
            "username": { "type": "string" },
            "password": { "type": "string" }
          },
          "required": ["username", "password"],
          "additionalProperties": false
        },
        {
          "type": "object",
          "properties": {
            "id_token": { "type": "string" },
            "customer_account_code": { "type": "string" }
          },
          "required": ["id_token", "customer_account_code"],
          "additionalProperties": false
        },
        {
          "type": "object",
          "properties": {
            "code": { "type": "string" },
            "customer_account_code": { "type": "string" }
          },
          "required": ["code", "customer_account_code"],
          "additionalProperties": false
        }
      ]
    },
    {
      "type": "object",
      "properties": {
        "hardware_id": { "type": "string" },
        "product": { "type": "string" },
        "license_id": { "type": "number" },
        "sdk_ver": { "type": "string" }
      },
      "required": ["hardware_id", "product"],
      "additionalProperties": false
    }
  ]
}
```

</details>

### Examples

{% tabs %}
{% tab title="curl" %}

```bash
curl --location --request POST '/api/v4/deactivate_bundle' \
--header 'Accept: application/json' \
--header 'Content-Type: application/json' \
--header 'Date: string' \
--header 'Authorization: string' \
--data-raw '{
  "hardware_id": "some-unique-id",
  "product": "BUNDLE",
  "license_key": "AAAA-BBBB-CCCC-DDDD"
}'
```

{% endtab %}

{% tab title="nodejs" %}

```javascript
var request = require('request');

var options = {
  method: 'POST',
  url: '/api/v4/deactivate_bundle',
  headers: {
    'Accept': 'application/json',
    'Content-Type': 'application/json',
    'Date': 'string',
    'Authorization': 'string'
  },
  body: JSON.stringify({
    hardware_id: 'some-unique-id',
    product: 'BUNDLE',
    license_key: 'AAAA-BBBB-CCCC-DDDD'
  })
};

request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

{% endtab %}

{% tab title="javascript (fetch)" %}

```javascript
var myHeaders = new Headers();
myHeaders.append("Accept", "application/json");
myHeaders.append("Content-Type", "application/json");
myHeaders.append("Date", "string");
myHeaders.append("Authorization", "string");

var raw = JSON.stringify({
  hardware_id: "some-unique-id",
  product: "BUNDLE",
  license_key: "AAAA-BBBB-CCCC-DDDD"
});

var requestOptions = {
  method: 'POST',
  headers: myHeaders,
  body: raw,
  redirect: 'follow'
};

fetch("/api/v4/deactivate_bundle", requestOptions)
  .then(response => response.text())
  .then(result => console.log(result))
  .catch(error => console.log('error', error));
```

{% endtab %}

{% tab title="python" %}

```python
import requests

url = "/api/v4/deactivate_bundle"

payload = {
  "hardware_id": "some-unique-id",
  "product": "BUNDLE",
  "license_key": "AAAA-BBBB-CCCC-DDDD"
}

headers = {
  "Accept": "application/json",
  "Content-Type": "application/json",
  "Date": "string",
  "Authorization": "string"
}

response = requests.post(url, json=payload, headers=headers)
print(response.text)
```

{% endtab %}

{% tab title="ruby" %}

```ruby
require "uri"
require "net/http"
require "json"

url = URI("/api/v4/deactivate_bundle")

http = Net::HTTP.new(url.host, url.port)
request = Net::HTTP::Post.new(url)
request["Accept"] = "application/json"
request["Content-Type"] = "application/json"
request["Date"] = "string"
request["Authorization"] = "string"
request.body = JSON.dump({
  hardware_id: "some-unique-id",
  product: "BUNDLE",
  license_key: "AAAA-BBBB-CCCC-DDDD"
})

response = http.request(request)
puts response.read_body
```

{% endtab %}
{% endtabs %}

### License Authorization Method

There are two types of product licenses based on how the client application authorizes itself to interact with a license:

#### Key-based product licenses

Each license assigned to the product requires the client to provide a license key in order to activate, check or deactivate the license (property license\_key in the request body).

The license response object will contain the license\_key property, and product\_details.authorization\_method will be the string license\_key.

#### User-based product licenses

Each license assigned to the product has a corresponding "license user" instead of a license key. There are multiple ways a user-based product license can be accessed when making a request:

* By providing the values for username and password for the license user
* By providing the values for id\_token (use access\_token value) and customer\_account\_code if using single sign-on authentication using Implicit grant
* By providing the values for code and customer\_account\_code if using single sign-on authentication using Authorization code grant

In the license response object, product\_details.authorization\_method will have the string value user and the response object will contain the user object with information on the license user.

### Errors

If an error occurs, the response will have an HTTP status code of 400 or higher, and the response body will contain an error description in the following format:

```typescript
{
  status: number,
  code: string,
  message: string
}
```

JSON Schema

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "status": { "type": "number" },
    "code": { "type": "string" },
    "message": { "type": "string" }
  },
  "required": [
    "status",
    "code",
    "message"
  ],
  "additionalProperties": false
}
```

<details>

<summary>List of Exceptions</summary>

* unknown\_product (400): Provided product was not found
* product\_not\_bundle (400): Specified product "code" is not a bundle
* license\_not\_found (400): License with the provided license user not found
* license\_not\_active (400): The license is not active
* device\_not\_found (400): An active device matching the hardware\_id not found
* missing\_headers (400): Some headers are missing

</details>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.licensespring.com/license-api/license-activation-and-deactivation/deactivate-bundle-online-method.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
